'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.extensions = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

var _babelrc = require('./babelrc');

var _babelrc2 = _interopRequireDefault(_babelrc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CURRENTDIR = _path2.default.join(__dirname, '..');
var BABEL_LOADER = 'babel-loader?' + (0, _stringify2.default)(_babelrc2.default);
var CSS_LOADER = 'css-loader?modules&importLoaders=2&sourceMap&localIdentName=[local]___[hash:base64:5]';
var SASS_LOADER = 'sass-loader?sourceMap';
var LESS_LOADER = 'less-loader?sourceMap';
var STYLE_LOADERS = ['style-loader', CSS_LOADER, 'postcss-loader'];

var extensions = exports.extensions = ['', '.web.js', '.js'];

exports.default = function (options) {
    return {
        context: options.context,
        entry: options.entry,
        output: options.output,
        devtool: options.devtool,

        postcss: function postcss() {
            return [_autoprefixer2.default];
        },


        plugins: [new _webpack2.default.NoErrorsPlugin(), new _webpack2.default.DefinePlugin({
            'process.env': {
                NODE_ENV: options.production ? '"production"' : '"developement"'
            }
        }), new _webpack2.default.LoaderOptionsPlugin({
            minimize: !!options.production,
            debug: !options.production
        })].concat(options.production ? [new _webpack2.default.optimize.DedupePlugin(), new _webpack2.default.optimize.UglifyJsPlugin({
            compress: { warnings: false },
            sourceMap: !!options.devtool
        })] : []).concat(options.plugins || []),

        module: {
            loaders: [{
                test: /\.js$/,
                exclude: /node_modules/,
                loader: BABEL_LOADER
            }, {
                test: /\.json$/,
                loader: 'json'
            }, {
                test: /\.css$/,
                loaders: STYLE_LOADERS
            }, {
                test: /\.less$/,
                loaders: [].concat(STYLE_LOADERS, [LESS_LOADER])
            }, {
                test: /\.scss$/,
                loaders: [].concat(STYLE_LOADERS, [SASS_LOADER])
            }, {
                test: /\.(gif|jpg|png|webp|svg)$/,
                loader: 'url?limit=25000'
            }]
        },

        resolveLoader: {
            modules: [_path2.default.join(CURRENTDIR, 'node_modules'), _path2.default.resolve(options.context, 'node_modules')]
        },

        resolve: {
            extensions: extensions,
            modules: [_path2.default.join(CURRENTDIR, 'node_modules'), _path2.default.resolve(options.context, 'node_modules')]
        }
    };
};
//# sourceMappingURL=configure-webpack.js.map