'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _memoryFs = require('memory-fs');

var _memoryFs2 = _interopRequireDefault(_memoryFs);

var _readFileAsync = require('./read-file-async');

var _readFileAsync2 = _interopRequireDefault(_readFileAsync);

var _writeFileAsync = require('./write-file-async');

var _writeFileAsync2 = _interopRequireDefault(_writeFileAsync);

var _configureBundler = require('./configure-bundler');

var _configureBundler2 = _interopRequireDefault(_configureBundler);

var _runCompilerAsync = require('./run-compiler-async');

var _runCompilerAsync2 = _interopRequireDefault(_runCompilerAsync);

var _formatHtml = require('./format-html');

var _formatHtml2 = _interopRequireDefault(_formatHtml);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(options) {
        var _this = this;

        var isRemote, ignoreTranspile, ignoreInline, compile, result, $, file;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        isRemote = function isRemote(uri) {
                            return (/^((https?:)?\/\/)/.test(uri)
                            );
                        };

                        ignoreTranspile = function ignoreTranspile(uri) {
                            return (/(\?|\?.+&)transpile=false/.test(uri)
                            );
                        };

                        ignoreInline = function ignoreInline(uri) {
                            return (/(\?|\?.+&)inline=false/.test(uri)
                            );
                        };

                        compile = function () {
                            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(compiler) {
                                var memoryFs, status, result;
                                return _regenerator2.default.wrap(function _callee$(_context) {
                                    while (1) {
                                        switch (_context.prev = _context.next) {
                                            case 0:
                                                memoryFs = new _memoryFs2.default();


                                                compiler.outputFileSystem = memoryFs;

                                                _context.next = 4;
                                                return (0, _runCompilerAsync2.default)(compiler);

                                            case 4:
                                                status = _context.sent;


                                                if (!options.quiet) {
                                                    console.log(status.toString({
                                                        colors: true
                                                    }));
                                                }

                                                result = status.toJson();

                                                if (!result.errors.length) {
                                                    _context.next = 9;
                                                    break;
                                                }

                                                throw result.errors;

                                            case 9:
                                                _context.next = 11;
                                                return (0, _readFileAsync2.default)(memoryFs, _path2.default.join(options.root, 'output.js'));

                                            case 11:
                                                return _context.abrupt('return', _context.sent);

                                            case 12:
                                            case 'end':
                                                return _context.stop();
                                        }
                                    }
                                }, _callee, _this);
                            }));

                            return function compile(_x2) {
                                return _ref2.apply(this, arguments);
                            };
                        }();

                        result = void 0;

                        if (!options.entry) {
                            _context4.next = 11;
                            break;
                        }

                        _context4.next = 8;
                        return (0, _readFileAsync2.default)(_fs2.default, _path2.default.join(options.root, options.entry));

                    case 8:
                        result = _context4.sent;
                        _context4.next = 12;
                        break;

                    case 11:
                        result = (0, _formatHtml2.default)(options.js || 'index.js');

                    case 12:
                        $ = _cheerio2.default.load(result);
                        _context4.next = 15;
                        return _promise2.default.all($('script').map(function () {
                            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(i, el) {
                                var src, content, parent, compiler;
                                return _regenerator2.default.wrap(function _callee2$(_context2) {
                                    while (1) {
                                        switch (_context2.prev = _context2.next) {
                                            case 0:
                                                src = $(el).attr('src');

                                                if (!(isRemote(src) || ignoreInline(src))) {
                                                    _context2.next = 3;
                                                    break;
                                                }

                                                return _context2.abrupt('return', null);

                                            case 3:
                                                content = void 0;

                                                if (!ignoreTranspile(src)) {
                                                    _context2.next = 10;
                                                    break;
                                                }

                                                _context2.next = 7;
                                                return (0, _readFileAsync2.default)(_fs2.default, _path2.default.join(options.root, src.split('?')[0]));

                                            case 7:
                                                content = _context2.sent;
                                                _context2.next = 17;
                                                break;

                                            case 10:
                                                parent = options.entry ? _path2.default.dirname(_path2.default.join(options.root, options.entry)) : options.root;
                                                _context2.next = 13;
                                                return (0, _configureBundler2.default)({
                                                    devtool: options.sourcemaps ? 'inline-source-map' : null,
                                                    root: options.root,
                                                    entry: ['./' + _path2.default.relative(options.root, _path2.default.join(parent, src))],
                                                    output: 'output.js',
                                                    production: options.production
                                                });

                                            case 13:
                                                compiler = _context2.sent;
                                                _context2.next = 16;
                                                return compile(compiler);

                                            case 16:
                                                content = _context2.sent;

                                            case 17:

                                                $(el).attr('src', null);
                                                $(el).text(content);

                                                return _context2.abrupt('return', src);

                                            case 20:
                                            case 'end':
                                                return _context2.stop();
                                        }
                                    }
                                }, _callee2, _this);
                            }));

                            return function (_x3, _x4) {
                                return _ref3.apply(this, arguments);
                            };
                        }()).get());

                    case 15:
                        _context4.next = 17;
                        return _promise2.default.all($('link[rel=stylesheet]').map(function () {
                            var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(i, el) {
                                var src, content, $style;
                                return _regenerator2.default.wrap(function _callee3$(_context3) {
                                    while (1) {
                                        switch (_context3.prev = _context3.next) {
                                            case 0:
                                                src = $(el).attr('href');

                                                if (!(isRemote(src) || ignoreInline(src))) {
                                                    _context3.next = 3;
                                                    break;
                                                }

                                                return _context3.abrupt('return', null);

                                            case 3:
                                                _context3.next = 5;
                                                return (0, _readFileAsync2.default)(_fs2.default, _path2.default.join(options.root, src.split('?')[0]));

                                            case 5:
                                                content = _context3.sent;
                                                $style = $('<style type="text/css">');


                                                $style.text(content);

                                                $(el).replaceWith($style);

                                                return _context3.abrupt('return', src);

                                            case 10:
                                            case 'end':
                                                return _context3.stop();
                                        }
                                    }
                                }, _callee3, _this);
                            }));

                            return function (_x5, _x6) {
                                return _ref4.apply(this, arguments);
                            };
                        }()).get());

                    case 17:
                        file = _path2.default.join(options.root, options.output || (options.entry ? _path2.default.basename(options.entry, '.html') : 'index') + '.quik.html');
                        _context4.next = 20;
                        return (0, _writeFileAsync2.default)(_fs2.default, file, $.html(), 'utf-8');

                    case 20:
                        return _context4.abrupt('return', _context4.sent);

                    case 21:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function (_x) {
        return _ref.apply(this, arguments);
    };
}();
//# sourceMappingURL=html.js.map