'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

exports.default = function (options) {
    var WORKINGDIR = options.root;

    var expanded = (0, _globExpand2.default)({ cwd: WORKINGDIR }, options.entry);
    var entry = {};

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = (0, _getIterator3.default)(expanded), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var e = _step.value;

            entry[e] = ['./' + e, 'webpack-hot-middleware/client'];
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    var config = (0, _configureWebpack2.default)({
        context: WORKINGDIR,
        devtool: options.devtool,
        production: false,
        plugins: [new _webpack2.default.HotModuleReplacementPlugin()],
        output: {
            path: WORKINGDIR,
            publicPath: '/',
            filename: '[name]'
        },
        entry: entry
    });

    var BABEL_LOADER = 'babel-loader?' + (0, _stringify2.default)((0, _extends3.default)({}, _babelrc2.default, {
        presets: [].concat((0, _toConsumableArray3.default)(_babelrc2.default.presets), [require.resolve('babel-preset-react-hmre')])
    }));

    var loaders = config.module.loaders;

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        for (var _iterator2 = (0, _getIterator3.default)(loaders), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var loader = _step2.value;

            if (loader.loader && loader.loader.indexOf('babel') > -1) {
                loader.loader = BABEL_LOADER;
            } else if (loader.loaders) {
                for (var i = 0, l = loader.loaders.length; i < l; i++) {
                    if (loader.loaders[i].indexOf('babel') > -1) {
                        loader.loaders[i] = BABEL_LOADER;
                        break;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }

    var compiler = (0, _webpack2.default)(config);

    return (0, _koaCompose2.default)([(0, _koaWebpackDevMiddleware2.default)(compiler, {
        publicPath: '/',
        noInfo: true
    }), (0, _koaWebpackHotMiddleware2.default)(compiler)]);
};

var _globExpand = require('glob-expand');

var _globExpand2 = _interopRequireDefault(_globExpand);

var _koaCompose = require('koa-compose');

var _koaCompose2 = _interopRequireDefault(_koaCompose);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _koaWebpackDevMiddleware = require('koa-webpack-dev-middleware');

var _koaWebpackDevMiddleware2 = _interopRequireDefault(_koaWebpackDevMiddleware);

var _koaWebpackHotMiddleware = require('koa-webpack-hot-middleware');

var _koaWebpackHotMiddleware2 = _interopRequireDefault(_koaWebpackHotMiddleware);

var _configureWebpack = require('./configure-webpack');

var _configureWebpack2 = _interopRequireDefault(_configureWebpack);

var _babelrc = require('./babelrc');

var _babelrc2 = _interopRequireDefault(_babelrc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=quik-middleware-hmr.js.map